import 'package:appmate_flutter/models/Metadata.dart';
import 'package:appmate_flutter/models/Offerwall.dart';
import 'package:appmate_flutter/models/Product.dart';
import 'package:flutter/material.dart';

class OfferwallDetail extends StatelessWidget {
  final Offerwall? offerwall;
  final String errorMsg;

  const OfferwallDetail(
      {Key? key, required this.offerwall, required this.errorMsg})
      : super(key: key);

  @override
  Widget build(BuildContext context) {
    Widget body = errorMsg.isNotEmpty
        ? Center(child: Text(errorMsg))
        : SingleChildScrollView(
            child: Padding(
              padding: EdgeInsets.all(20),
              child: Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  Text('ID : ${offerwall!.offeringId!}'),
                  Text('-------------'),
                  Text('defaultOffer : ${offerwall!.defaultOffer!}'),
                  Text('-------------'),
                  Text('Description : ${offerwall!.description!}'),
                  Text('Products'),
                  Text('-------------'),
                  for (Product product in offerwall!.products!)
                    Text('Product Id : ${product.productId}'),
                  Text('-------------'),
                  Text('Metadata'),
                  for (Metadata metadata in offerwall!.metadata!)
                    Text(
                        'id : ${metadata.id}, type : ${metadata.type}, value : ${metadata.value}\n')
                ],
              ),
            ),
          );

    return Scaffold(
      resizeToAvoidBottomInset: false,
      backgroundColor: Colors.grey[200],
      appBar: AppBar(
        title: Text('Offerwall Details'),
        centerTitle: false,
        backgroundColor: Colors.redAccent,
      ),
      body: body,
    );
  }
}
