import 'package:appmate_flutter/PurchaseClient.dart';
import 'package:appmate_flutter/helpers/MakePurchaseResponse.dart';
import 'package:appmate_flutter/models/Product.dart';
import 'package:appmate_flutter_example/util.dart';
import 'package:flutter/material.dart';

class ProductRow extends StatefulWidget {
  final Product p;

  const ProductRow({Key? key, required this.p}) : super(key: key);

  @override
  State<ProductRow> createState() => _ProductRowState();
}

class _ProductRowState extends State<ProductRow> {
  Future<void> makePurchase(Product product) async {
    MakePurchaseResponse response;
    try {
      response = await PurchaseClient.makePurchase(product);
      if (response.error != null) {
        Util.showDialog(context, response.error!.message ?? "Unknown Error");
      } else {
        Util.showDialog(context, "Purchase success");
      }
    } on Exception {}

    if (!mounted) return;
  }

  @override
  Widget build(BuildContext context) {
    return ListTile(
      title: Text(
        widget.p.productLocales![0].productName!,
        style: const TextStyle(fontSize: 18),
      ),
      subtitle: Text(widget.p.productId!),
      trailing: Text(
        (widget.p.price()) + ' ' + widget.p.currency(),
        style: const TextStyle(fontSize: 18),
      ),
      onTap: () {
        makePurchase(widget.p);
      },
    );
  }
}
