import 'package:appmate_flutter/models/Product.dart';

import 'Metadata.dart';

class Offerwall {
  final String? offeringId;
  final String? description;
  final List<Metadata>? metadata;
  final List<Product>? products;
  final bool? defaultOffer;

  Offerwall(this.offeringId, this.description, this.metadata, this.products,
      this.defaultOffer);

  Offerwall.fromJson(Map<String, dynamic> json)
      : offeringId = json['offeringId'],
        description = json['description'],
        metadata = json['metadata'] != null
            ? List<Metadata>.from(
                json['metadata'].map((model) => Metadata.fromJson(model)))
            : null,
        products = json['products'] != null
            ? List<Product>.from(
                json['products'].map((model) => Product.fromJson(model)))
            : null,
        defaultOffer = json['defaultOffer'];

  Map<String, dynamic> toJson() => {
        'offeringId': offeringId,
        'description': description,
        'metadata': metadata,
        'products': products,
        'defaultOffer': defaultOffer
      };
}
