import 'package:appmate_flutter/models/SubscriptionPriceChange.dart';

/// An object which keeps all information about a purchase.

/// After a purchase transaction, all the information created is kept in PurchaseInfo objects.
class PurchaseInfo {
  final String? userId;
  final String? uspAppId;
  final String? productId;
  final String? orderId;
  final String? purchaseTime;
  final int? purchaseStatus;
  final String? purchaseToken;
  final bool? autoRenew;
  final String? developerPayload;
  final String? platform;
  final bool? sandbox;
  final String? purchaseType;
  final int? consumed;
  final String? country;
  final String? currency;
  final String? price;
  final String? subGroupId;
  final String? cancelReason;
  final String? expireTime;
  final String? lastOrderId;
  final bool? inTrialPeriod;
  final String? introductoryPrice;
  final String? renewPrice;
  final String? graceExpireTime;
  final int? renewTime;
  final int? discountRenewTime;
  final String? nextRenewTime;
  final SubscriptionPriceChange? priceChange;
  final String? autoResumeTime;
  final String? linkedPurchasedToken;
  final String? receiptData;

  PurchaseInfo(
      this.userId,
      this.uspAppId,
      this.productId,
      this.orderId,
      this.purchaseTime,
      this.purchaseStatus,
      this.purchaseToken,
      this.autoRenew,
      this.developerPayload,
      this.platform,
      this.sandbox,
      this.purchaseType,
      this.consumed,
      this.country,
      this.currency,
      this.price,
      this.subGroupId,
      this.cancelReason,
      this.expireTime,
      this.lastOrderId,
      this.inTrialPeriod,
      this.introductoryPrice,
      this.renewPrice,
      this.graceExpireTime,
      this.renewTime,
      this.discountRenewTime,
      this.nextRenewTime,
      this.priceChange,
      this.autoResumeTime,
      this.linkedPurchasedToken,
      this.receiptData);

  PurchaseInfo.fromJson(Map<String, dynamic> json)
      : userId = json['userId'],
        uspAppId = json['uspAppId'],
        productId = json['productId'],
        orderId = json['orderId'],
        purchaseTime = json['purchaseTime'],
        purchaseStatus = json['purchaseStatus'],
        purchaseToken = json['purchaseToken'],
        autoRenew = json['autoRenew'],
        developerPayload = json['developerPayload'],
        platform = json['platform'],
        sandbox = json['sandbox'],
        purchaseType = json['purchaseType'],
        consumed = json['consumed'],
        country = json['country'],
        currency = json['currency'],
        price = json['price'],
        subGroupId = json['subGroupId'],
        cancelReason = json['cancelReason'],
        expireTime = json['expireTime'],
        lastOrderId = json['lastOrderId'],
        inTrialPeriod = json['inTrialPeriod'],
        introductoryPrice = json['introductoryPrice'],
        renewPrice = json['renewPrice'],
        graceExpireTime = json['graceExpireTime'],
        renewTime = json['renewTime'],
        discountRenewTime = json['discountRenewTime'],
        nextRenewTime = json['nextRenewTime'],
        priceChange = json['priceChange'] != null
            ? SubscriptionPriceChange.fromJson(json['priceChange'])
            : null,
        autoResumeTime = json['autoResumeTime'],
        linkedPurchasedToken = json['linkedPurchasedToken'],
        receiptData = json['receiptData'];
}
